$(document).ready(function() {

  initTooltips();
  initVideoChannel();
  initServiceId();

  // Fill form
  $('#sportzcastEnabled').val(serviceArrTmp[activeItem].enabled ? "Yes" : "No");
  $('#sportzcastCustomName')
    .val(serviceArrTmp[activeItem].customName || '')
    .keyup(onCustomNameKeyUp)
    .attachValidation({
      pattern: '^[A-Za-z0-9 -]{0,}$',
      invalidMsg: 'Only chars A-Z, a-z, 0-9, white space and dash are allowed.',
      disableBtnId: 'saveBtn'
    });
  $('#sportzcastUrl').val(serviceArrTmp[activeItem].xml_url);
  createTriggeringElement('#sportzcastAutomationType', serviceArrTmp[activeItem].automationType, serviceArrTmp[activeItem].schedule);
  createVideoChannelElement('#sportzcastVideoChannel', serviceArrTmp[activeItem].camera).then(function(){
    // Callbacks for changes
    $('.form-control').change(formChangedCallback);

    formChangedCallback();
  });

  createScheduleBtn();
});

function formChangedCallback() {
  serviceArrTmp[activeItem].enabled = $('#sportzcastEnabled').val() == 'Yes' ? 1 : 0;
  serviceArrTmp[activeItem].customName = $('#sportzcastCustomName').val();

  if (!isMips()) {
    if(enabledServicesCount() > 8 || enabledServicesPerVideoChannel(serviceArrTmp[activeItem].camera) > 4) {
      serviceArrTmp[activeItem].enabled = 0;
      $('#sportzcastEnabled').val('No');
      showMessage('warning', 'A maximum of four services can be enabled simultaneously in one Video Channel and eight services can run in total.', false, 'maxFourServices');
    }
  } else {
    if(enabledServicesCount() > 2) {
      serviceArrTmp[activeItem].enabled = 0;
      $('#sportzcastEnabled').val('No');
      showMessage('warning', 'Maximally two services can be enabled simultaneously.', false, 'maxTwoServices');
    }
  }

  serviceArrTmp[activeItem].xml_url = $('#sportzcastUrl').val();

  serviceArrTmp[activeItem].automationType = $('#sportzcastAutomationType').val();
  serviceArrTmp[activeItem].camera = saveVideoChannelValue(serviceArrTmp[activeItem].camera, $('#sportzcastVideoChannel'));
  createCameraPreview($('#sportzcastVideoChannel'), {}, serviceArrTmp[activeItem].camera);

  showSaveWarning();
  createServiceList(serviceArrTmp);
}